----Skin Team Presentation
function sc_School_onrelease()
    sc_close_local_menu()
    ui_xhtml_sublayer.FILENAME = "ui_igo9/" .. CREDITS_folder .. "/school.xhtml"
    sc_NextStateAnim(st_xhtml, "horz_scroll", 1, "")
    txtTitle.TEXT = m_i18n("GPSforum School Team")
end
--start settigs skin=================================
createState("st_Gpsforum_Extra_Settings")
st_Gpsforum_Extra_Settings:useLayers(backgroundLayers, ui_Gpsforum_Extra_Settings)
st_Gpsforum_Extra_Settings.init = function()
	txtTitle:SET(m_i18n("Team Gpsforum - Extra Settings"))
end

sc_btnASM_Gpsforum_Extra_Settings_OnRelease = function()
  sc_NextStateAnim(st_Gpsforum_Extra_Settings, "horz_scroll", 1, "")
end 

createState("st_maneuver_Settings")
st_maneuver_Settings:useLayers(backgroundLayers, ui_maneuver_Settings)
st_maneuver_Settings.init = function()
	txtTitle:SET(m_i18n("Maneuver"))
end

sc_biz_maneuver_OnRelease = function()
  sc_NextStateAnim(st_maneuver_Settings, "horz_scroll", 1, "")
end 

	lm_CockpitList.no_route:append(lm_CockpitList[vCockpitFieldNoRoute4()])
	lm_CockpitList.has_route:append(lm_CockpitList[vCockpitField4()])

-- transparenta
createState("st_biz_btntransparency")
st_biz_btntransparency:useLayers(backgroundLayers, ui_biz_btntransparency)
st_biz_btntransparency.init = function()
	txtTitle:SET(m_i18n("Transparency settings"))
end

sc_btnASM_biz_btntransparency_OnRelease = function()
  sc_NextStateAnim(st_biz_btntransparency, "horz_scroll", 1, "")
end 
-- visual settings
createState("st_biz_visualsettings")
st_biz_visualsettings:useLayers(backgroundLayers, ui_biz_visualsettings)
st_biz_visualsettings.init = function()
	txtTitle:SET(m_i18n("Visual settings"))
end

sc_btnASM_biz_visualsettings_OnRelease = function()
  sc_NextStateAnim(st_biz_visualsettings, "horz_scroll", 1, "")
end 

sc_TurnRestrictionAlertSound = function ()
    if MODEL.lua.vnavigation.turn.restriction.icon.valid.valid() then
        PLAYSOUND("alarmeffect", "!ding")
    end
end
----Mapchanger
MODEL.SETPERSISTENT.lua.vgjMCCurrentMap = INT_MODEL(1)

sc_wMapChanger_OnRelease = function()
	sc_NextStateAnim(st_wMapChanger, "horz_scroll", 1, "")
end

createState("st_wMapChanger")
st_wMapChanger:useLayers(backgroundLayers, ui_wMapChanger)
st_wMapChanger.init = function()
	txtTitle.TEXT = m_i18n("Mapchanger")
end

sc_wMapChanger_go = function(provider)
	if MODEL.lua.vgjMCCurrentMap() ~= provider then
		wProvider = provider
		MODEL.screen.msgbox.new.setup(2)
		MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to change Map provider?"))
		MODEL.screen.msgbox.new.setup_button(1, "sc_wMapChanger_goDone", m_i18n("Change provider"), L"", "ico_done_mid.bmp#3")
		MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
		MODEL.screen.msgbox.create_new()
	end	
end

sc_wMapChanger_goDone = function()
	MODEL.lua.vgjMCCurrentMap = wProvider
	local param = L"," .. towstring(wProvider)
	NEXTSTATE(RestartState)
	doDelayed(15, function()
		START_APPLICATION(L"utility/mapchanger.exe",param)
		doDelayed(1,EXIT)
	end)
end

sc_gjMapchangerProvider_check = function()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L"%content%/map"
	oasisFiles.filter = L"fcategory:1"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_MapsScan_Finished:START("NO_TRIGGER")
end

sc_Mapchanger_check_done = function()
	obs_Files_MapsScan_Finished:STOP()
	local name = L""
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		name = MODEL.oasis.files.list[i].fname()
		if name == L"!map_ta.txt" or name == L"!MAP_TA.TXT" then
			MODEL.lua.vgjMCCurrentMap = 1
			break
		end
		if name == L"!map_nt.txt" or name == L"!MAP_NT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 2
			break
		end
		if name == L"!map_ot.txt" or name == L"!MAP_OT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 3
			break
		end
		if name == L"!map_us.txt" or name == L"!MAP_US.TXT" then
			MODEL.lua.vgjMCCurrentMap = 4
			break
		end
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
end 

sc_gjMapchangerProvider_check()
--Restart
sc_wRestart_OnRelease = function()
	sc_wShowNewMessageBox(m_i18n("The program will restart."),"sc_wRestart_OnReleaseDone", m_i18n("Restart"),"ico_done_mid.bmp#3",nil,"sc_CancelExit")
end
 
sc_wRestart_OnReleaseDone = function()
	SAVESETTINGS()
	NEXTSTATE(RestartState)
	doDelayed(25, APP_RESTART)
end

sc_wShowNewMessageBox = function(text1,f_button1,text_button1,icon_button1,text2,f_button2)
	local typetext1 = type(text1) == "wstring" and "_wstr" or ""
	local f_cancel = f_button2 ~= "nil" and f_button2 or ""
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new["set_line"..typetext1](1, text1)
	if text2 ~= nil then
		local typetext2 = type(text2) == "wstring" and "_wstr" or ""
		MODEL.screen.msgbox.new["set_line"..typetext2](2, text2)
	end
	MODEL.screen.msgbox.new.setup_button(1, f_button1, text_button1, "", icon_button1)
	MODEL.screen.msgbox.new.setup_button(2, f_cancel, m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
--POI
wCurrentGroup = 0
wCurrentGroupFav = -1
wAddPOIposition	= 0
wLastScrollPos = 0
wBackfromVisibility = false
wGroupIcon = nil

sc_Go_PicturePoiList_orig = sc_Go_PicturePoiList
sc_Go_PicturePoiList = function()
		sc_close_local_menu()
	sc_ExecuteFlatSearch(poi_search_params.picturepoi_search)
	sc_NextStateAnim(st_FindPOIFlatList, "fade")
end

st_POIVisibilities.enter_orig = st_POIVisibilities.enter
st_POIVisibilities.enter = function()
	EPoiScrollPos = {}
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
end

st_POIVisibilities.init_orig = st_POIVisibilities.init
st_POIVisibilities.init = function()
	sc_SetTitlePOIVisibilities()
	sc_init_local_menu("ui.lm_moremenu_poi_visibilities")
	if wBackfromVisibility then
		wBackfromVisibility = false
		local LastScrollPos = EPoiScrollPos[table.maxn(EPoiScrollPos)]
		wLastScrollPos = LastScrollPos
		local structure = MODEL.poi.structure
		table.remove(EPoiScrollPos)
		structure.to_parent()
		structure.execute()
		doDelayed(1, function()
			MODEL.ui.lst_PoiVisList.scroll_pos = LastScrollPos
		end
		)
	end
end
 
st_POIVisibilities.done_orig = st_POIVisibilities.done
st_POIVisibilities.done = function()
	wBackfromVisibility = false
	sc_SavePOIVisibility()
end
 
sc_back_POIGroupVisibility = function()
	wBackfromVisibility = true
	sc_back()
end
 
sc_ManagePOIGroupVisibility = function(mode)
	table.insert(EPoiScrollPos, MODEL.ui.lst_PoiVisList.scroll_pos())
	local structure = MODEL.poi.structure
	structure.group_list.index = MODEL["*"]._index()
	structure.to_child()
	structure.execute()
	wCurrentGroup = structure.search_root()
	MODEL.my.poi.select_group(MODEL.poi.structure.search_root())
	sc_NextStateAnim(st_ManagePOIGroupVisibility, "horz_scroll", 1, "")
end
 
sc_ChangeCurrentPoiGroupIcon = function(group)
	wGroupIcon = group
	if not sc_GetSysEntry("poi", "sort_icons", 1) then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
	elseif MODEL.ui.list_wScreenIcons.isempty() then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
		local iconbmp, iconphase = nil, nil
		for i = 0, MODEL.screen.icons.size() - 1 do
			iconbmp, iconphase = MODEL.screen.get_icon_file_and_phase(MODEL.screen.icons[i](), 2)
			if not (string.sub(iconbmp,1,1) == "*" or string.sub(iconbmp,1,1) == ";") then
				ui.list_wScreenIcons:add({bmp=iconbmp, phase=iconphase, icon=MODEL.screen.icons[i]()})
			end
		end
		ui.list_wScreenIcons:sort("phase")
		ui.list_wScreenIcons:sort("bmp")
	end
	sc_NextStateAnim(st_ManagePOIGroupIcon, "horz_scroll", 1, "")
end

sc_CurrentPoiGroupIconSelected = function()
	if wGroupIcon then
		MODEL.my.poi.current_group.icon = MODEL["*"].icon()
	else
		MODEL.my.poi.current.icon = MODEL["*"].icon()
	end
	sc_back()
end

createState("st_ManagePOIGroupVisibility")
st_ManagePOIGroupVisibility:useLayers(backgroundLayers, ui_ManagePOIGroupVisibility)
st_ManagePOIGroupVisibility.init = function()
	txtTitle.TEXT = m_i18n("Set Place Visibility")
	MODEL.lua.wCurrentGroupFavourite = (wCurrentGroup == wCurrentGroupFav)
	MODEL.lua.wPoiGroupAltitude = MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at()
	btn_Footer_back_1:ONRELEASE(sc_back_POIGroupVisibility)
end
 
st_ManagePOIGroupVisibility.done = function()
	MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at = MODEL.lua.wPoiGroupAltitude()
	sc_SavePOIVisibility()
	btn_Footer_back_1:ONRELEASE(sc_back)
end
 
createState("st_ManagePOIGroupIcon")
st_ManagePOIGroupIcon:useLayers(backgroundLayers, ui_ManagePOIGroupIcon)
st_ManagePOIGroupIcon.init = function()
	txtTitle.TEXT = m_i18n("Select Place Icon")
end
 
st_ShowPOIInfo.enter = function()
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
end
sc_Poi_Visibilities_orig = sc_Poi_Visibilities
sc_Poi_Visibilities = function()
	sc_SetPoiVisibilities()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	MODEL.lua.poi.selectedPOIVis = MODEL.poi.structure.visibility_array()
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
	sc_NextStateAnim(st_POIVisibilities, "horz_scroll", 1, "")
end

sc_AddPOI = function()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
	sc_NextStateAnim(st_AddPOI, "fade", 1, "")
end

createState("st_AddPOI")
st_AddPOI:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_AddPOI.enter = function()
	EPoiScrollPos = {}
end

st_AddPOI.init = function()
	sc_wSetTitle_AP()
end

sc_Structure_ToChildAP = function()
	table.insert(EPoiScrollPos, MODEL.ui.lst_AP.scroll_pos())
	local structure = MODEL.poi.structure
	structure.group_list.index = MODEL["*"]._index()
	structure.to_child()
	structure.execute()
	MODEL.ui.lst_AP.scroll_pos = 0
	sc_wSetTitle_AP()
end

sc_Structure_ToParentAP = function()
	local structure = MODEL.poi.structure
	local LastScrollPos = EPoiScrollPos[table.maxn(EPoiScrollPos)]
	table.remove(EPoiScrollPos)
	structure.to_parent()
	structure.execute()
	sc_wSetTitle_AP()
	doDelayed(1, function()
		MODEL.ui.lst_AP.scroll_pos = LastScrollPos
	end
	)
end

sc_wSetTitle_AP = function()
	local title = translate(m_i18n("Add POI")) .. (MODEL.poi.structure.parent_name() and	L" - " or L"") .. MODEL.poi.structure.parent_name()
	local titlealt = translate(m_i18n("Select group")) .. (MODEL.poi.structure.parent_name() and	L" - " or L"") .. MODEL.poi.structure.path_text()
	if vActiveState() == "st_addpoi" then
		txtTitle:SET(title)
	else
		txtTitle:SET(titlealt)
	end
end

sc_CreateNewGroupMainAP = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(L"")
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI group name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_CreateNewGroupDoneAP)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("Create POI Group"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
	MODEL.regional.keyboard.load_panel_by_name(L"QWERTY")
	MODEL.lua.wLocalMenuHide = true
end
 
sc_CreateNewGroupDoneAP = function()
	name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New Group>"
	end
	name = "@"..tostring(name)
	name = m_i18n(name)
	MODEL.my.poi.add_group(MODEL.poi.structure.search_root(), MODEL.poi.find_provider("userpoi"), name)
 	MODEL.poi.structure.execute()
	PREVSTATE()
end
 
sc_AddPOIToGroupMain = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(L"")
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_SetNewPOIName)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("Create POI"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_SetNewPOIName = function()
	local name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New POI>"
	end
	MODEL.my.poi.add_poi_selected(MODEL.poi.structure.search_root(), MODEL.poi.find_provider("userpoi"))
	MODEL.my.poi.current.name = name
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	sc_SelectSavedFavorites()
	PREVSTATE()
	PREVSTATE()
	NEXTSTATE(st_ShowPOIInfo)
end

sc_ModifyPOINameMain = function()
	sc_close_local_menu()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.my.poi.current.name())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_ModifyPOIName)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("New POI name"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_ModifyPOIName = function()
	local name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New POI>"
	end
	MODEL.my.poi.current.name = name
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	PREVSTATE()
end

sc_ModifyPOIPhoneMain = function()
	sc_close_local_menu()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.my.poi.current.phone())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI phone number>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_ModifyPOIPhone)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("New POI phone number"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
	MODEL.regional.keyboard.load_panel_by_name(L"Phone")
	MODEL.lua.wLocalMenuHide = true
end

sc_ModifyPOIPhone = function()
	MODEL.my.poi.current.phone = ui.inpSI_Text.VALUE()
	PREVSTATE()
end

sc_wLMDeletePOI = function()
	local text2 = MODEL.my.map.selected_item.name()
	local newMsgBox = MODEL.screen.msgbox.new
	newMsgBox.setup(2)
	newMsgBox.set_line(1, m_i18n("Are you sure you want to delete this POI?"))
	newMsgBox.set_line_wstr(2, text2)
	newMsgBox.setup_button(1, "sc_wLMDeletePOI_OK", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	newMsgBox.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wLMDeletePOI_OK = function()
	MODEL.my.poi.current.remove()
	MODEL.poi.resultpoi.clear()
	MODEL.my.map.select_address(MODEL.map.cursor.position())
	sc_ResetStrappedCursor()
	if vActiveState() == "st_easynav" then
		sc_start_ExitDragMode()
	end
end

sc_DeletePoiGroup = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete Group and all POIs in this Group?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_DeletePoiGroupDone", m_i18n("Delete"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end

sc_DeletePoiGroupDone = function()
	sc_back_POIGroupVisibility()
	NEXTSTATE(st_DeletePoiGroupEmpty)
end

createState("st_DeletePoiGroupEmpty")
st_DeletePoiGroupEmpty.init = function()
	MODEL.my.poi.delete_content(wCurrentGroup, MODEL.poi.find_provider("userpoi"))
	MODEL.my.poi.delete_group(wCurrentGroup, MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.execute()
	PREVSTATE()
	doDelayed(1, function()
		MODEL.ui.lst_PoiVisList.scroll_pos = wLastScrollPos
	end
	)
end
--car poz
obs_wcursorup = var.observer({ONCHANGE = function()
	if not st_EasyNav.active or MODEL.lua.dragMode() or MODEL.lua.wPosition_cursorup() == 80 then
		return
	end
	local mapLayer = MODEL.map.primary()
	if mapLayer.car_posy() == 80 then
		mapLayer.car_posy = MODEL.lua.wPosition_cursorup()
	end
	if mapLayer.center_posy() == 80 then
		mapLayer.center_posy = MODEL.lua.wPosition_cursorup()
	end
end, MODEL = {MODEL.map.primary.car_posy, MODEL.map.primary.center_posy}, TRIGGER_ON_START = true})
local sc_cursorup_st_EasyNav_init = st_EasyNav.init
st_EasyNav.init = function()
	sc_cursorup_st_EasyNav_init()
	obs_wcursorup:START()
end
local sc_cursorup_st_EasyNav_done = st_EasyNav.done
st_EasyNav.done = function()
	sc_cursorup_st_EasyNav_done()
	obs_wcursorup:STOP()
end
--car size
sc_vehicle_size = function()
  MODEL.map.car_display.map_scale = MODEL.lua.APVehicle_size()
end
 
gCarZoomModeTimeOutID = -1
sc_CarZoomMode_On = function()
  MODEL.lua.CarZoomMode = true
  sc_SetCarZoomMode_TimeOut()
end
 
sc_CarZoomMode_Off = function()
  MODEL.lua.CarZoomMode = false
  sc_vehicle_size()
end
 
sc_CarZoomChanged = function()
  sc_vehicle_size()
end
 
sc_SetCarZoomMode_TimeOut = function()
  killDelayed(gCarZoomModeTimeOutID)
  gCarZoomModeTimeOutID = doDelayed(500, sc_CarZoomMode_Off)
end

sc_CarSize_Reset = function()
  MODEL.lua.APVehicle_size = 100
end
-- zoom
wInpValueInteger_min = 0
wInpValueInteger_max = 0
wInpValueInteger_needsign = false
wInpValueInteger_model = ""
wTmpdateDelimiter = nil
wUnitConvMeter2Unit = {float.new("1.093613298"), float.new("1.0"), float.new("3.280839895")}
	
createState("st_InputValueInteger")
st_InputValueInteger:useLayers(backgroundLayers, "ui_InputValueInteger")
st_InputValueInteger.init = function()
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_name(L"Core Numbers")
	MODEL.lua.InputValidatorIsDate = true
	wTmpdateDelimiter = MODEL.lua.dateDelimiter()
	MODEL.lua.dateDelimiter = 0
end
 
st_InputValueInteger.done = function()
	closeKeyboard:trigger()
	KEY("RETURN")
	MODEL.lua.InputValidatorIsDate = false
	MODEL.lua.dateDelimiter = wTmpdateDelimiter
	MODEL.regional.keyboard.on_close_panel()
	MODEL.regional.keyboard.smartkey_model("")
end
 
sc_inpValueInteger_onchange = function()
	local inptext = ui.inpValueInteger.VALUE()
	local tempinptext = wstring.sub(inptext, 1, 1) == L"-" and wstring.sub(inptext, 2, #inptext) or inptext
	local acceptable, InputKeys = getNextInput_Int(tempinptext, wInpValueInteger_min, wInpValueInteger_max)
	MODEL.lua.keyb_done = acceptable
	MODEL.lua.fuelinputkeys = InputKeys .. (#inptext == 0 and wInpValueInteger_needsign and L"-" or L"")
	MODEL.regional.keyboard.smartkey_model("lua.fuelinputkeys")
end
 
sc_SelectValueInteger = function(title, donefunction, min, max, needsign, donemodel)
	wInpValueInteger_min = min
	wInpValueInteger_max = max
	wInpValueInteger_needsign = needsign
	if donemodel ~= nil then
		wInpValueInteger_model = donemodel
	end
	local emptytitle = (needsign and (L"-" .. towstring(max)) or towstring(min)) .. L".." .. towstring(max)
	sc_NextStateAnim(st_InputValueInteger, "horz_scroll", 1, "")
	txtTitle.TEXT = m_i18n(title)
	inpValueInteger.value = L""
	inpValueInteger.EMPTYTITLE = translated_format(m_i18n("<Enter Number (%s)>"), emptytitle)
	sc_inpValueInteger_onchange()
	KEY("RETURN", donefunction)
	ui.vKeyTableDone = donefunction
end
 
inpValueInteger_isempty = function()
	local result = var.new()
	inpValueInteger:ISEMPTY(result)
	return result()
end

sc_SelectIntegerDistanceDone = function()
	if not inpValueInteger_isempty() then
		MODEL[wInpValueInteger_model] = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	sc_back()
end

sc_Angle_SP = function()
	local camerasettings = MODEL.map.primary.camera_settings()
	camerasettings.restore()
	camerasettings.roundabout.centery = 65
	camerasettings.presetid = 10 * (MODEL.lua.vEasyViewMode() + 1) + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		camerasettings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
		camerasettings.maxangle = MODEL.lua.wZoom_maxangleSP()
		camerasettings.angleoffset = MODEL.lua.wZoom_maxangleSP()
		camerasettings.defaultangle = MODEL.lua.wZoom_maxangleSP()
	else
		camerasettings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Angle_notSP = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.camera_settings.restore()
	mapLayer.camera_settings.roundabout.centery = 50
	mapLayer.car_posy = (MODEL.lua.vEasyMapMode() == EMapMode.Mode_3D and 80 or (MODEL.lua.vEasyMapMode() == 3 and 50 or (MODEL.route.vehicle_type() == EVehicleType.Pedestrian and 70 or 80)))
	mapLayer.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		mapLayer.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_RestoreSmartZoom = function()
	sc_Angle_notSP()
end
 
sc_Set_Presets = function()
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets()
	end
	MODEL.map.primary.camera_settings.restore()
	MODEL.map.primary.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		MODEL.map.primary.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Set_wUser_Presets = function()
	local settings = MODEL.map.primary.camera_settings()
	sc_Set_wUser_Presets_followzoom()
	settings.minangle = MODEL.lua.wZoom_minangle()
	settings.maxangle = MODEL.lua.wZoom_maxangle()
	settings.angleoffset = MODEL.lua.wZoom_maxangle()
	settings.defaultangle = MODEL.lua.wZoom_maxangle()
	settings.lowspeed = MODEL.lua.wZoom_speedlow()
	settings.highspeed = MODEL.lua.wZoom_speedhigh()
	if not MODEL.lua.wZoom_lockzoom() then
		settings.speedzoom = MODEL.lua.wZoom_speedzoom()
		if MODEL.lua.wZoom_speedzoom() then
			settings.speedzoom_use_minmax = true
		end
	end
	settings.speedangle = MODEL.lua.wZoom_speedangle()
	if MODEL.lua.wZoom_speedangle() then
		settings.speedangle_use_minmax = true
	end
	settings.overview_enabled = MODEL.lua.wZoom_overview_enabled() and not MODEL.lua.wZoom_lockzoom()
	if MODEL.lua.wZoom_overview_enabled() then
		settings.overview_distance = MODEL.lua.wZoom_overview_distance()
		settings.overview_zoom2d = MODEL.lua.wZoom_overview_zoom2d()
		settings.overview_zoom3d = MODEL.lua.wZoom_overview_zoom3d()
		settings.overview_angle = MODEL.lua.wZoom_overview_angle()
	end
end
 
sc_Set_wUser_Presets_followzoom = function()
	if MODEL.lua.wUserZoomSetting() and MODEL.lua.wZoom_lockzoom() then
		MODEL.map.primary.zoom_follow = false
		MODEL.map.primary.zoom = (MODEL.map.primary.mode() == "3d" and MODEL.lua.wZoom_defaultzoom3d() or MODEL.lua.wZoom_defaultzoom2d())
	else
		MODEL.map.primary.zoom_follow = not MODEL.lua.dragMode()
	end
end

sc_Easy3D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("navmap3d", 1)
	mapLayer.mode = "3d"
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_3D()
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
end
 
sc_Easy2D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dheadup", 1)
	mapLayer.mode = "2d"
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
		mapLayer.zoom_follow = false
		mapLayer.car_posy = 70
		mapLayer.center_posy = 70
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.car_posy = 80
		mapLayer.center_posy = 80
	end
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end
 
sc_Easy2D_NU = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dnorthup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
	end
	mapLayer.zoom_follow = true
	mapLayer.car_posy = 50
	mapLayer.center_posy = 50
	if not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.center_follow = true
		mapLayer.rotate = 0
		mapLayer.rotate_follow = false
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end
 
sc_Easy3DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("navmap3d", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
		mapLayer.rotate_follow = false
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
		mapLayer.rotate_follow = true
	end
end
 
sc_Easy2DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dheadup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.breadcrumbs = true
		mapLayer.center_posy = 50
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.breadcrumbs = false
		mapLayer.center_posy = 80
	end
end
 
sc_Easy2D_NU_FromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dnorthup", 1)
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
	sc_Set_wUser_Presets_followzoom()
	mapLayer.center_posy = 50
	mapLayer.car_posy = 50
end
 
sc_set_3dDem = function()
	local value = MODEL.map.primary["3d_dem"]()
	local valueNeg = 0
	if value == 0 then
		valueNeg = 3
	end
	MODEL.map.primary.setglobal = true
	MODEL.map.primary.setglobal_filter = wGetNUSupported and "navmap3d,2dheadup,2dnorthup,simulate,simulate_2d,simulate_2d_nu" or "navmap3d,2dheadup,simulate,simulate_2d"
	MODEL.map.primary["3d_dem"] = valueNeg
	MODEL.map.primary["3d_dem"] = value
	MODEL.map.primary.setglobal = false
end
 
sc_Set_Follow_On = function()
	local mapLayer = MODEL.map.primary()
	if MODEL.route.vehicle_type() ~= EVehicleType.Pedestrian then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
	mapLayer.center_follow = true
	mapLayer.rotate_follow = mapLayer.state() ~= "2dnorthup" and mapLayer.state() ~= "simulate_2d_nu"
	if mapLayer.state() == "2dnorthup" or mapLayer.state() == "simulate_2d_nu" then
		mapLayer.rotate = 0
	end
end

sc_MapSettings_Zoom = function()
	sc_NextStateAnim(st_MapSettings_Zoom, "horz_scroll", 1, "")
end

sc_wGetZoomSettingIndexes = function()
	local t = {}
	local group = ""
	for item,index in ModelList_iter(ui.ZoomSettingList.list) do
		if group ~= item.group() then
			group = item.group()
			table.insert(t, index)
		end
	end
	return t
end
 
sc_Select_wZoom_minangleDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_minangle = text
		if MODEL.lua.wZoom_maxangle() < text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	sc_back()
end
 
sc_Select_wZoom_maxangleDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangle = text
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	sc_back()
end
 
sc_Select_wZoom_maxangleSPDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangleSP = text
		if MODEL.lua.wZoom_maxangle() > text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
	end
	sc_back()
end
 
sc_Select_wZoom_speedlowDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = regional.units:convert("Speed", "km/h", text, "miles/hour")
			text = double.round(text):toInt()
		end
		MODEL.lua.wZoom_speedlow = text
		if MODEL.lua.wZoom_speedhigh() < text then
			MODEL.lua.wZoom_speedhigh = text
		end
	end
	sc_back()
end
 
sc_Select_wZoom_speedhighDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = regional.units:convert("Speed", "km/h", text, "miles/hour")
			text = double.round(text):toInt()
		end
		MODEL.lua.wZoom_speedhigh = text
		if MODEL.lua.wZoom_speedlow() > text then
			MODEL.lua.wZoom_speedlow = text
		end
	end
	sc_back()
end

createState("st_MapSettings_Zoom")
st_MapSettings_Zoom:useLayers(backgroundLayers, "ui_List_Background", "ui_MapSettings_Zoom")
st_MapSettings_Zoom.init = function()
	txtTitle.TEXT = m_i18n("User zoom settings")
end

sc_ConvertInputDistToCurrent = function(dist)
	return float.toInt(float.new(tostring(dist)) * wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
end

st_MapSettings_Zoom.exit = function()
	sc_Set_Presets()
end

function sc_Easy2Ddragmode()
	local mapLayer = MODEL.map.primary()
		sc_Set_Common_2DMap(mapLayer)
	if(MODEL.route.vehicle_type() == EVehicleType.Pedestrian) then
		mapLayer.center_posy = 70
	else
		mapLayer.center_posy = 80
	end

	carPosySave = mapLayer.center_posy()
	MODEL.lua.dragMode = true
	MODEL.lua.tiltVisible = false

	mapLayer.zoom_lock = false
	mapLayer.rotate_lock = false
	mapLayer.center_lock = false

	mapLayer.center_follow = false
	mapLayer.zoom_follow = false
	mapLayer.rotate_follow = false

	if(MODEL.route.vehicle_type() == EVehicleType.Pedestrian) then
		mapLayer.breadcrumbs = true
	else
		mapLayer.breadcrumbs = false
	end

	mapLayer.navi_mode_3d_labels = false
end

function sc_Easy3DFromDragmode()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false

	mapLayer.switch_state("navmap3d", 1)
	if(MODEL.route.vehicle_type() == EVehicleType.Pedestrian) then
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
		mapLayer.rotate_follow = false
	else
		mapLayer.zoom_follow = true
		mapLayer.tilt_follow = true
		mapLayer.rotate_follow = true
	end
end

function sc_Easy2DFromDragmode()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false

	mapLayer.switch_state("2dheadup", 1)
	if(MODEL.route.vehicle_type() == EVehicleType.Pedestrian) then
		mapLayer.zoom_follow = false
		mapLayer.breadcrumbs = true
		mapLayer.center_posy = 50
	else
		mapLayer.zoom_follow = true
		mapLayer.breadcrumbs = false
		mapLayer.center_posy = 80
	end
end

sc_Easy2D_NU_FromDragmode = function()
  local mapLayer = MODEL.map.primary()
  MODEL.lua.dragMode = false
  MODEL.lua.tiltVisible = false
  mapLayer.switch_state("2dnorthup", 1)
  if(MODEL.route.vehicle_type() == EVehicleType.Pedestrian) then
    mapLayer.breadcrumbs = true
  else

    mapLayer.breadcrumbs = false
  end
  mapLayer.zoom_follow = true
  mapLayer.center_posy = 50
  mapLayer.car_posy = 50
end
--2d/3d
function sc_set_Nav2D3D()
	if(MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D) then
		sc_Easy2D()
	elseif(MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D_NU) then
        sc_Easy2D_NU()
	else
	sc_Easy3D()
	end
end

function sc_set_Nav2D3D_in_dragmode()
	if MODEL.map.primary.zoom() > maxZoom then
		return
	end
		local mapLayer = MODEL.map.primary()
	if (MODEL.map.primary.mode() ~= "2d") then
		mapLayer.autochange_mode_for_zoom = false
		 sc_Easy2Ddragmode()
	else
		mapLayer.autochange_mode_for_zoom = true
		 sc_Easy3Ddragmode()
	end  	
end

function sc_set_Nav2D3D_MapSettings()
	local mapLayer = MODEL.map.primary()
	mapLayer.car_posx = 50
	mapLayer.center_posx = 50		
	sc_set_Nav2D3D()
	mapLayer.car_posx = 25
	mapLayer.center_posx = 25
end
-- speed tolerance ---------------------------------------------
sc_gjSPfix_tolerance_change = function()
	if MODEL.warning.speedwarn_alt_toltype() then
		MODEL.warning.speedwarn_alt_tolerance = MODEL.lua.vgjspeed_in_city()
		MODEL.warning.speedwarn_tolerance = MODEL.lua.vgjspeed_out_of_city()
	else
		MODEL.warning.speedwarn_alt_tolerance = MODEL.lua.vgjspeed_in_city()+100
		MODEL.warning.speedwarn_tolerance = MODEL.lua.vgjspeed_out_of_city()+100
	end
	MODEL.warning.speedwarn_toltype = MODEL.warning.speedwarn_alt_toltype()
end

st_SpeedWarningSettings.exit = function()
	sc_gjSPfix_tolerance_change()
end

sc_GetAdvancedSpeedLimitPhase_orig = sc_GetAdvancedSpeedLimitPhase
sc_GetAdvancedSpeedLimitPhase = function(speed, speed_limit)
	if MODEL.navigation.car.is_incity() then
		if MODEL.warning.speedwarn_alt_toltype() then 
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit + MODEL.warning.speedwarn_alt_tolerance() then
				return 1
			else
				return 2
			end	
		else
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit * MODEL.warning.speedwarn_alt_tolerance() / 100 then
				return 1
			else
				return 2
			end	
		end
	else	
		if MODEL.warning.speedwarn_alt_toltype() then 
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit + MODEL.warning.speedwarn_tolerance() then
				return 1
			else
				return 2
			end	
		else
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit * MODEL.warning.speedwarn_tolerance() / 100 then
				return 1
			else
				return 2
			end	
		end
  end
end
-- simulate --
tSimControlsObjectsNew = {"spr_SC_bg", "btn_ManNext", "spr_ManNext", "btn_sim_play", "spr_sim_play", "btn_sim_pause", "spr_sim_pause", "btn_ManPrev", "spr_ManPrev", "btnSpeedSimUp", "sprSpeedSimUp", "btnSpeedSimNormal", "sprSpeedSimNormal", "btnSpeedSimDown", "sprSpeedSimDown"}

sc_StartFadeSimControls_orig = sc_StartFadeSimControls
sc_StartFadeSimControls = function(from, to, time)
	for cntr = 1, #tSimControlsObjectsNew do
		_G[tSimControlsObjectsNew[cntr]]:BLENDALPHA(from, to, time)
	end
	scroll_SC:ALPHA(to)
end
 
sc_RestartSimControlsDelay_orig = sc_RestartSimControlsDelay
sc_RestartSimControlsDelay = function()
	sc_ResetSimControlsDelay()
	sc_StartFadeSimControls(gSimControlsFadeMin, gSimControlsFadeMax, gSimControlsFadeInTime)
	gSimControlsFadeDelayID = doDelayed(200, "sc_FadeOutSimControls()")
end 
--U-turn
sc_biz_uturnonoff = function()
  if MODEL.lua.bizAvoidUTurn() then
    MODEL.route.allow_uturn = false
  else
    MODEL.route.allow_uturn = true
  end
end
-- programs
gjSelectProgramMode = false

sc_zz_ExternalPrograms_OnRelease = function()
	gjSelectProgramMode = false
	sc_NextStateAnim(st_gjUserPrograms, "fade", 1, "")
end

createState("st_gjUserPrograms")
st_gjUserPrograms:useLayers(backgroundLayers, ui_gjUserPrograms)
st_gjUserPrograms.init = function()
	txtTitle:SET(m_i18n("Select program"))
end
 
sc_gj_UserProgramsOnRelease = function()
	local current = MODEL.ui.gjUserProgramList[MODEL["*"]._index()]
	if gjSelectProgramMode then
		MODEL.lua.gjMenuLCProgram = MODEL["*"]._index()
		sc_back()
	elseif current.exit() then
		NEXTSTATE(RestartState)
		doDelayed(15, function()
			START_APPLICATION(current.path(),current.parameter())
			doDelayed(1,EXIT)
		end
		)
	else
		START_APPLICATION(current.path(),current.parameter())
	end
end
 
sc_gj_UserProgramsEdit_OnRelease = function()
	local current = MODEL.ui.gjUserProgramList[MODEL["*"]._index()]
	sc_gjUserProgramsEdit_OnRelease = MODEL["*"]._index()
	MODEL.lua.gjProgramName = current.name()
	MODEL.lua.gjSettingProgramParameter = current.parameter()
	MODEL.lua.gjSettingProgramExOn = current.exit()
	sc_NextStateAnim(st_gjUserProgramsEdit, "horz_scroll", 1, "")
end
 
createState("st_gjUserProgramsEdit")
st_gjUserProgramsEdit:useLayers(backgroundLayers, ui_gjUserProgramsEdit)
st_gjUserProgramsEdit.init = function()
	txtTitle:SET(m_i18n("Edit program entry"))
end
 
st_gjUserProgramsEdit.exit = function()
	local current = MODEL.ui.gjUserProgramList[sc_gjUserProgramsEdit_OnRelease]
	current.name = MODEL.lua.gjProgramName()
	current.parameter = MODEL.lua.gjSettingProgramParameter()
	current.exit = MODEL.lua.gjSettingProgramExOn()
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_EditProgramName = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.lua.gjProgramName())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter program name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_gj_EditProgramNameDone)
	inputFieldRequired = false
	txtTitle:SET(m_i18n("Set program name"))
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_EditProgramParameter = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.lua.gjSettingProgramParameter())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter program parameter>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_gj_EditProgramParameterDone)
	inputFieldRequired = false
	txtTitle:SET(m_i18n("Set program parameter"))
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_gj_EditProgramNameDone = function()
	MODEL.lua.gjProgramName = ui.inpSI_Text.VALUE()
	sc_back()
end

sc_gj_EditProgramParameterDone = function()
	MODEL.lua.gjSettingProgramParameter = ui.inpSI_Text.VALUE()
	sc_back()
end
 
sc_gj_UserProgramsDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this program from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_UserProgramsDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_UserProgramsDel_OnRelease_OK = function()
	MODEL.ui.gjUserProgramList.remove(MODEL.ui.gjUserProgramList.list.index())
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_UserProgramsAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all programs from list?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_UserProgramsAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_UserProgramsAll_OnRelease_OK = function()
	MODEL.ui.gjUserProgramList.clear()
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_RescanwUserPrograms_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The previous list will be removed. Are you sure you want to rescan programs?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_RescanwUserPrograms_OnReleaseOK", m_i18n("Rescan programs"), L"", "ico_Done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_RescanwUserPrograms_OnReleaseOK = function()
	ui_gjProgramScanning:SHOW()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L""
	oasisFiles.filter = L"fcategory:2"
	oasisFiles.filter_type = L"PROGRAM"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_UserProgramScan_Finished:START("NO_TRIGGER")
end
 
sc_gj_RescanwUserPrograms_done = function()
	obs_Files_UserProgramScan_Finished:STOP()
	ui_gjProgramScanning:HIDE()
	MODEL.ui.gjUserProgramList.clear()
	local filename = L""
	local fpath = L""
	local length = 0
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		filename = MODEL.oasis.files.list[i].fname()
		fpath = MODEL.oasis.files.list[i].frootpath()
		length = wstring.len(fpath)
		fpath = wstring.sub(fpath, 7, length)
		ui.gjUserProgramList:add({name=filename, path=fpath, parameter=L"", exit=0})
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_RescanwUserPrograms_stop = function()
	obs_Files_UserProgramScan_Finished:STOP()
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	ui_gjProgramScanning:HIDE()
end