MODEL.SETPERSISTENT.lua.wdattsvoice_datts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wTTSProGuidancePriority_datts = BOOL_MODEL(true)
wDASpeakingID_datts = 0
wTestSpeakingID_datts = 0
wLockSpeakingID_datts = -1
sc_wDADing_restart = function()
	if not MODEL.EXISTS.lua.wReadOutDASupported() then
		obs_DriverAlertWarn:STOP()
		obs_DriverAlertWarn_datts:START("NO_TRIGGER")
	end
end
sc_DADing_datts = function()
	if st_EasyNav.isActive and vDAIsVisible() and MODEL.lua.DAEnabled() and not MODEL.lua.dragMode() and not MODEL.lua.vVehicleIsPedestrian() and (not MODEL.navigation.curr_speedcam.category.valid() or MODEL.warning["speedcam_visualtype_" .. MODEL.navigation.curr_speedcam.category()]() == 0) and not MODEL.lua.showDiriconBg() then
		if sc_wReadOutDASupported_sign_datts() and MODEL.lua.wdattsvoice_datts() then
			sc_wDAsayspeech_datts(sc_wGetDADing_sayphase_datts())
		else
			PLAYSOUND("alarmeffect", "!ding")
		end
	end
end
sc_wReadOutDASupported_datts = function()
	local res = MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Soon")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("and"))
	if not res then
		return res
	end
	for i = 0, MODEL.ui.list_wDATypes_datts.unfiltered_list.size() - 1 do
		if not MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[i].text()) then
			res = false
			break
		end
	end
	return res
end
sc_wReadOutDASupported_sign_datts = function()
	local da = MODEL.warning.driveralert
	return MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Soon")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("and")) and (da.alerts.size() > 1 and MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[da.alerts[0].type()].text()) and MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[da.alerts[1].type()].text()) or MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[da.alerts[0].type()].text()))
end
sc_wTTSProPriorityVisible_datts = function()
	return MODEL.lua.wdattsvoice_datts() and sc_wReadOutDASupported_datts() and MODEL.lua.DAEnabled() and not MODEL.EXISTS.lua.wReadOutDASupported()
end
sc_wDAsayspeech_datts = function(text)
	if MODEL.sound.os_muted() or MODEL.sound.voice_muted() then
		return
	end
	if not MODEL.lua.wTTSProGuidancePriority_datts() then
		MODEL.sound.speech.unlock(wLockSpeakingID_datts)
	end
	if wDASpeakingID_datts then
		PromptCancel(wDASpeakingID_datts)
		wDASpeakingID_datts = 0
	end
	if wSpeedLimitSpeakingID_sltts then
		PromptCancel(wSpeedLimitSpeakingID_sltts)
		wSpeedLimitSpeakingID_sltts = 0
	end
	if wReserveSpeakingID_datts then
		PromptCancel(wReserveSpeakingID_datts)
		wReserveSpeakingID_datts = 0
	end
	if MODEL.lua.wTTSProGuidancePriority_datts() then
		if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
			wDASpeakingID_datts = MODEL.sound.speech.say("voice.ui", text, {priority=20, boosted_priority=25, callback = function(res) if res > 1 then wDASpeakingID_datts = 0 end end})
		end
	else
		wLockSpeakingID_datts = MODEL.sound.speech.lock()
		wDASpeakingID_datts = MODEL.sound.speech.say("voice.ui", text, {lock_id = wLockSpeakingID_datts, unlock_after_done = true, priority = 100, boosted_priority = 100, callback = function(res) if res > 1 then wDASpeakingID_datts = 0 end end})
	end
end
sc_wGetDADing_sayphase_datts = function()
	local da = MODEL.warning.driveralert
	if da.settings.warn_method() == 1 then
		return da.alerts.size() > 1 and sc_wGetDADing_sayphase_sign_datts(da.alerts[0].type(), da.alerts[0].is_active()) .. L" " .. sc_wGetDADing_sayphase_sign_datts(da.alerts[1].type(), da.alerts[1].is_active(), da.alerts[0].is_active()) or sc_wGetDADing_sayphase_sign_datts(da.alerts[0].type(), da.alerts[0].is_active())
	else
		local iconmodel = da.alerts.size() > 1 and da.alerts[1].is_active() and 1 or 0
		return da.alerts.size() > 1 and da.alerts[0].is_active() and da.alerts[1].is_active() and sc_wGetDADing_sayphase_sign_datts(da.alerts[0].type(),true) .. L", " .. sc_wGetDADing_sayphase_sign_datts(da.alerts[1].type(),true) or sc_wGetDADing_sayphase_sign_datts(da.alerts[iconmodel].type(),true)
	end
end
sc_wGetDADing_sayphase_sign_datts = function(signindex,signactive,signprevactive)
	local phrase = signindex < MODEL.ui.list_wDATypes_datts.unfiltered_list.size() and MODEL.ui.list_wDATypes_datts.unfiltered_list[signindex].text() or ""
	return translate_voice(not signactive and (signprevactive ~= nil and not signprevactive and "and" or "Soon") or "") .. (not signactive and L" " or L"") .. translate_voice(phrase)
end
wDATypesTemp_builded_datts = false
sc_wWarningSignSoundTTS_OnRelease_datts = function()
	if not wDATypesTemp_builded_datts then
		sc_wDATypesTemp_build_datts()
	end
	sc_NextStateAnim(st_wWarningSignSoundTTS_datts, "horz_scroll", 1, "")
end
sc_wDATypesTemp_build_datts = function()
	MODEL.screen.filter_unique_by_index(DAiconIdx + 1)
	MODEL.screen.set_current_icongroup("sys")
	local iconbmp = nil
	local res = (DAiconIdx == 4 and "high/" or (DAiconIdx == 2 and "mid/" or "low/"))
	res = "images/da/" .. res
	local iconbmp_saved = "___"
	for i = 0, MODEL.screen.icons.size() - 1 do
		iconbmp = MODEL.screen.get_icon_file_and_phase(MODEL.screen.icons[i](), DAiconIdx + 1)
		if string.find(iconbmp, res) ~= nil then
			ui.list_wDATypesTemp_datts:add({bmp=string.gsub(iconbmp, res, "")})
		end
	end
	ui.list_wDATypesTemp_datts:sort("bmp")
	for i = 0, MODEL.ui.list_wDATypesTemp_datts.size() - 1 do
		iconbmp = MODEL.ui.list_wDATypesTemp_datts[i].bmp()
		if string.find(iconbmp, iconbmp_saved) == nil and iconbmp ~= "na.bmp" then
			iconbmp_saved = string.sub(iconbmp, 1, 3)
			local currentDA = MODEL.ui.list_wDATypes_datts.unfiltered_list[tonumber(iconbmp_saved)]
			if currentDA.bmp() == "na.bmp" then
				currentDA.bmp = iconbmp
			end
		end
	end
	MODEL.ui.list_wDATypesTemp_datts.clear()
	wDATypesTemp_builded_datts = true
end
createState("st_wWarningSignSoundTTS_datts")
st_wWarningSignSoundTTS_datts:useLayers(backgroundLayers, ui_wWarningSignSoundTTS_datts)
st_wWarningSignSoundTTS_datts.init = function()
	txtTitle.TEXT = m_i18n("Warning Sign TTS Pro Test")
end
st_wWarningSignSoundTTS_datts.done = function()
	if wTestSpeakingID_datts then
		PromptCancel(wTestSpeakingID_datts)
		wTestSpeakingID_datts = 0
	end
end
sc_wGetPhaseBmpDA_sayTest_datts = function()
	return "images/da/" .. (DAiconIdx == 4 and "high/" or (DAiconIdx == 2 and "mid/" or "low/")) .. MODEL["*"].bmp()
end
sc_wDATTSVoice_play_datts = function()
	if wTestSpeakingID_datts then
		PromptCancel(wTestSpeakingID_datts)
		wTestSpeakingID_datts = 0
	end
	if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
		wTestSpeakingID_datts = MODEL.sound.speech.say("voice.ui", translate_voice(MODEL["*"].text()), {callback = function(res) if res > 1 then wTestSpeakingID_datts = 0 end end})
	end
end
sc_wDADing_restart()
